<?php

/**
 * tipo_bolsa actions.
 *
 * Link: http://http://localhost/contratacion/web/api_dev.php/api/tipo_bolsa/list.json
 * 
 * @package    contratacion
 * @subpackage tipo_bolsa
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class tipo_bolsaActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        /**
         * Solicitar token de conexion - 20200910
         */
        $respuesta = CN_TABLE::solicitarToken();
        $this->logMessage("tipo_bolsa Token: " . $respuesta);

        /*
         * Manejo de errores
         */
        try {

            //Variables app.yml
            $sisgestion = sfConfig::get('app_sisgestion');

            /**
             * URLs
             */
            $uridos = $sisgestion . '/api/ServicePaa/bolsas';
            $urldos = 'http://' . $uridos;

            //Datos de filtro
            $post = '';

            //Token de autorizacion
            $authorization = "Authorization: Bearer " . $respuesta;

            /*
             * Llamado CURL
             */
            $sesion = curl_init($urldos);

            //Define el tipo de ejecución
            curl_setopt($sesion, CURLOPT_HTTPHEADER, array('Content-Type: application/json', $authorization));
            curl_setopt($sesion, CURLOPT_CUSTOMREQUEST, "GET");
            curl_setopt($sesion, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($sesion, CURLOPT_POSTFIELDS, $post);
            curl_setopt($sesion, CURLOPT_FOLLOWLOCATION, 1);

            //Ejecuta la petición
            $result = curl_exec($sesion);
            //Se cierra la conexión
            curl_close($sesion);

            //verificar Message en result
            $pos = strpos($result, 'Message');
            if ($pos !== false) {
                throw new Exception("La respuesta del servicio fue erronea; favor verificar.");
            }

            $resultt = array();
            $respuesta = array();
            $resultt = json_decode($result);
            $this->logMessage("tipo_bolsa Respuesta: " . $result);


            foreach ($resultt as $res) {
                $record = array();
                foreach ($res as $key => $value) {
                    if (is_array($value)) {

                        $key = strtolower($key);
                        $re = array();
                        foreach ($value as $va) {
                            $r = array();
                            foreach ($va as $ke => $val) {
                                $ke = strtolower($ke);

                                $r[strtolower($ke)] = $val;
                            }
                            $re[] = $r;
                        }
                        $re = json_encode($re);
                        $record[strtolower($key)] = $re;
                    } else {
                        $key = strtolower($key);
                        $record[strtolower($key)] = $value;
                    }
                }

                $respuesta[] = $record;
            }

            /**
             * Respuesta de consulta
             */
            $this->totalRows = count($respuesta);
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($respuesta);
            $this->list_data = $respuesta;
            $this->logMessage("[tipo_bolsa] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array(
                array(
                    'code' => $e->getCode(),
                    'mensaje' => $e->getMessage(),
                    'servicio' => 'tipo_bolsa',
                    'modulo' => 'CONTRATACION'
                )
            );
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
